# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we have old versions of Test::More and Carp
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-Parallel-Runner
Version:	0.013
Release:	10.%{__distinit}%{__distvers}
Summary:	An object to manage running things in parallel processes
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		https://metacpan.org/release/Parallel-Runner
Source0:	http://cpan.metacpan.org/authors/id/E/EX/EXODIST/Parallel-Runner-%{version}.tar.gz
Patch0:		Parallel-Runner-0.013-T::E.patch
Patch1:		Parallel-Runner-0.013-test-count.patch
Patch2:		Parallel-Runner-0.013-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Module::Build) >= 0.40
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Child) >= 0.009
BuildRequires:	perl(POSIX)
BuildRequires:	perl(strict)
BuildRequires:	perl(Time::HiRes)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Test::Exception)
BuildRequires:	perl(Test::More)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
There are several other modules to do this, you probably want one of them. This
module exists as a super-specialized parallel task manager. You create the
object with a process limit and callbacks for what to do while waiting for a
free process slot, as well as a callback for what a process should do just
before exiting.

You must explicitly call $runner->finish() when you are done. If the runner is
destroyed before its children are finished, a warning will be generated and
your child processes will be killed, by force if necessary.

If you specify a maximum of 1 then no forking will occur, and run() will block
until the coderef returns. You can force a fork by providing a boolean true
value as the second argument to run(), which will force the runner to fork
before running the coderef; however, run() will still block until the child
exits.

%prep
%setup -q -n Parallel-Runner-%{version}

# Use Test::Exception rather than Text::Exception::LessClever
%patch0

# Fix test skip count
%patch1

# We need to patch the test suite if we have an old version of Test::More
%if %{old_test_more}
%patch2
%endif

%build
perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0
%{_fixperms} $R%{buildroot}

%check
RUN_KILL_TESTS=1 ./Build test

%clean
rm -rf %{buildroot}

%files
%doc CHANGES README
%{perl_vendorlib}/Parallel/
%{_mandir}/man3/Parallel::Runner.3*

%changelog
* Thu Sep 15 2016 Paul Howarth <paul@city-fan.org> - 0.013-10
- Classify buildreqs by usage
- Drop %%defattr, redundant since rpm 4.4

* Thu Sep 11 2014 Paul Howarth <paul@city-fan.org> - 0.013-6
- Drop %%defattr, redundant since rpm 4.4

* Thu Aug 15 2013 Paul Howarth <paul@city-fan.org> - 0.013-2
- Enable the optional "kill" tests

* Wed Aug 14 2013 Paul Howarth <paul@city-fan.org> - 0.013-1
- Initial RPM version
